import traceback

def error(condition, error_info, package_info="", remove=2):
    """
    Check error and show information.
    :param conditon: Check condition. (bool)
    :param error_info: Use to show info when the error occur. (str)
    :param package_info: Project name. (str)
    :param remove: Delete stack number. (int)
    :return:
    """
    try:
        assert condition
    except:
        for i in range(0, len(traceback.format_stack()) - remove):
            cprint(traceback.format_stack()[i][1::], "red", end=" ")

        info = "[%s] " % (package_info) + "[%s] " % ("Error")
        cprint(info + error_info, "red")
        exit(7)

def warn(condition, warn_info, package_info="", remove=2):
    """
    Check warn and show information.
    :param condition: Check condition. (bool)
    :param warn_info: Use to show info when the error occur. (str)
    :param package_info: Project name. (str)
    :param remove: Delete stack number. (int)
    :return:
    """
    try:
        assert condition
    except:
        for i in range(0, len(traceback.format_stack()) - remove):
            cprint(traceback.format_stack()[i][1::], "yellow", end=" ")

        info = "[%s] " % (package_info) + "[%s] " % ("Warn")
        cprint(info + warn_info, "yellow")

def cprint(content, color="black", end="\n", bold=False):
    """
    Colored print.
    :param content: Print content. (str)
    :param color: Color name. (str)
    :param end: End format. (str)
    :param bold: Bold or not. (bool)
    :return:
    """
    bold = 1 if bold else 0

    print("\033[%d;%sm%s\033[0m" % (bold, color_serial(color), content), end=end)

def color_serial(color):
    """
    Format color number.
    :param color: Choose color name. (str)
    :return:
    """
    color_dict = {
        "black": 30,
        "red": 31,
        "green": 32,
        "yellow": 33,
        "blue": 34,
        "purple": 35,
        "cyan": 36,
        "gray": 37,
        "lightgray": 38
    }

    return color_dict[color]